<!DOCTYPE html>
<html>
	<head>
		<!-- Permet d'utiliser des chemins (URI) relatifs au dossier du projet PHP -->
		<base href="<?=str_replace("\\", "/", explode("www", __DIR__)[1])?>/" />
		<!-- Titre de la page web -->
		<title>Exercices de PHP</title>	
		<!-- Métadonnées permettant d'éviter des problèmes d'affichage des contenus textuels -->
		<meta charset="UTF-8" />
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<!-- Favicon, c'est-à-dire icône figurant dans l'onglet sur le navigateur -->
		<link rel="icon" type="image/png" href="img/logo.png" />
		<!-- Feuille(s) de styles CSS -->
		<link rel="stylesheet" href="css/index.css" />
		<!-- Script(s) JavaScript -->
		<script src="https://code.jquery.com/jquery-3.3.1.min.js"></script>
		<script src="js/index.js"></script>
	</head>
	<body>
		
		<!-- Menu fixe de la page d'accueil (liens internes) -->

		<img class="mobile" src="img/menu.png" />
		
		<nav class="menu">
			<ul>
				<li><a href="#h1-html">Langages HTML et CSS</a></li>
				<li><a href="#h1-php">Langage PHP</a></li>
				<li><a href="#h1-env">Environnement de travail</a></li>
				<li><a href="#h1-exemples">Exemples PHP</a></li>
				<li><a href="#h1-exercices">Exercices PHP</a></li>
			</ul>
		</nav>
		
		<div class="author">Par : Monsieur J. Paquereau<br/>Lycée Benjamin Franklin</div>
		
		<!-- Contenu de la page d'accueil (rubriques) -->
	
		<section class="contenu">
						
			<h1 id="h1-html">Langages HTML et CSS</h1>			
			
			<div class="phrase">
				Au travers de l'introduction au HTML et au CSS que nous avons 
				effectuée, vous avez créé vos premières pages web et avez ainsi 
				commencé à apprende :
				<br/>
				- à rédiger le contenu de pages web en HTML ;
				<br/>
				- à mettre en forme ce contenu en CSS.
				<br/><br/>
				Vous êtes ainsi familiarisés avec diverses notions : les balises 
				ouvrantes, les balises fermantes, un certain nombre de balises 
				usuelles, l'usage d'attributs, les sélecteurs CSS, les règles 
				de mise en forme, etc.
				<br/><br/>
				Nous aurons finalement constaté qu'il y avait des limites au seul 
				usage des langages HTML et CSS, lesquels ne sont pas des langages de 
				programmation.
				<br/><br/>
				Si vous souhaitez plus d'informations concernant les langages HTML 
				et CSS, vous pouvez vous référer au :
				<br/><br/>
				<a href="https://www.orleans-informatique.com/info/stmg/cours/Cours - Q3 - html et css.pdf" target="_blank"> 
					Cours - Q3 - html et css
				</a>
			</div>
			
			<h1 id="h1-php">Langage PHP</h1>
			
			<div class="phrase">
				Au travers de ce cours, nous allons étudier le langage de programmation 
				PHP. Nous aurons besoin des langages HTML et CSS. Cependant, c'est la 
				programmation PHP qui va nous intéresser. A l'issue de ce cours, 
				vous devez :
				<br/>
				- avoir retenu* les notions et syntaxes PHP que nous aurons étudiées ;
				<br/>
				- avoir une idée de ce qu'est l'architecture "client-serveur" ;
				<br/>
				- savoir "qui fait quoi", par exemple : c'est le navigateur qui interprète 
				le HTML et le CSS ou encore le JavaScript, c'est le serveur web (exemple : 
				WampServer) qui interprète le PHP, etc.
				<br/><br/>
				<i>* Retenir: verbe signifiant "avoir compris et mémorisé".</i> 
				<br/><br/>
				Il s'agit bien ici de "savoirs", de "connaissances", mais également et 
				surtout de "savoirs-faire". Car l'objectif est bien que vous soyez 
				capable de comprendre, créer et/ou adapter une page web ou un programme 
				PHP.
				<br/><br/>
				Finalement, le PHP va nous permettre de créer des pages web interactives, 
				c'est-à-dire avec par exemple des formulaires. Il va nous permettre de 
				programmer (variables, conditions, boucles, fonctions, procédures, etc.) 
				mais encore de nous interconnecter avec une base de données en vue de 
				conserver de et manipuler des informations.
				<br/><br/>
				Si vous souhaitez plus d'informations concernant le langage PHP, vous 
				pouvez vous référer au :
				<br/><br/>
				<a href="https://www.orleans-informatique.com/info/stmg/cours/Cours - Q3 - web et php.pdf" target="_blank"> 
					Cours - Q3 - web et php
				</a>
			</div>
			
			<h1 id="h1-env">Environnement de travail</h1>
			
			<div class="phrase">
				Afin de développer nos pages web, nous utilisons et utiliseront :
				<br/>
				- le logiciel WampServer qui fait office de serveur web. C'est le logiciel 
				serveur qui permettra d'interpréter le contenu PHP de nos pages web. C'est 
				encore le logiciel auquel le navigateur s'adresse en utilisant le procole 
				HTTP ;
				<br/>
				- le logiciel Chrome qui sera le navigateur que nous utiliserons par défaut. 
				Rien ne vous empêche d'en utiliser un autre bien entendu. Le navigateur est 
				le logiciel client qui discute avec le serveur web au moyen du protocole HTTP. 
				C'est encore le logiciel qui interprète le contenu HTML et CSS final de nos 
				pages web ;
				<br/>
				- le logiciel Notepad++ qui sera l'éditeur que nous utiliserons pour 
				développer/coder nos pages web.
				<br/><br/>
				Pour plus d'informations concernant ces aspects "réseaux", vous pouvez vous 
				référer au :
				<br/><br/>
				<a href="https://www.orleans-informatique.com/info/stmg/cours/Cours - Q6.pdf" target="_blank"> 
					Cours - Q6 - réseaux et travail collaboratif
				</a>
				<br/><br/>
				Par ailleurs, pour travailler à la maison, vous aurez besoin de WampServer 
				que pouvez librement télécharger sur le :
				<br/><br/>
				<a href="http://www.wampserver.com/" target="_blank"> 
					Site officiel de WampServer
				</a>
				<br/><br/>
				Cependant, WampServer est destiné aux utilisateurs de Windows. Pour ceux qui 
				utiliseraient le système d'exploitation Linux ou encore OS X (Apple), vous 
				aurez besoin de LAMP (Linux) ou de MAMP (OS X). Ces logiciels sont également 
				téléchargeables en ligne.
			</div>
			
			<h1 id="h1-exemples">Exemples PHP</h1>
						
			<div class="phrase">
				Liste d'exemples PHP :
			</div>
						
			<ul class="exemples">
				<li>
					<div class="title">Les variables et tableaux en PHP</div>
					<div class="description">
						On montre ici comment utiliser des variables en PHP, quels sont 
						les types de variables simples en PHP et comment effectuer 
						des opérations usuelles (addition, multiplication, concaténation, 
						etc.) à l'aide de variables. On introduit également les notions 
						de tableaux et de tableaux associatifs en PHP.
					</div>
					<div class="fichiers">
						Fichier(s) : php/exemples/variables.php <br/> 
					</div>
					<div class="liens">
						<a href="php/exemples/variables.php">Voir l'exemple</a>
					</div>
				</li>
				<li>
					<div class="title">Les conditions en PHP</div>
					<div class="description">
						On montre ici comment utiliser les conditions en PHP, c'est-à-dire 
						la structure "if(condition){ ... }else if(...){ ... }else{ ... }". 
						On introduit les opérations comparaison (&lt;, &lt;=, ==, !=, ...) 
						mais également quelques fonctions de "test" permettant entre autres 
						de mettre en place des validations de données. 
						
					</div>
					<div class="fichiers">
						Fichier(s) : php/exemples/conditions.php <br/> 
					</div>
					<div class="liens">
						<a href="php/exemples/conditions.php">Voir l'exemple</a>
					</div>
				</li>
				<li>
					<div class="title">Les paramètres GET, POST et SESSION en PHP</div>
					<div class="description">
						On apprend ici comment interagir avec l'utilisateur, c'est-à-dire 
						comment récupérer des informations fournies par l'utilisateur 
						de l'interface et comment manipuler les informations que celui-ci 
						a transmises. Pour ce faire, on introduit les notions de paramètres 
						GET et POST. On introduit également la notion de paramètres 
						de session.
					</div>
					<div class="fichiers">
						Fichier(s) : php/exemples/parametres.php <br/> 
					</div>
					<div class="liens">
						<a href="php/exemples/parametres.php">Voir l'exemple</a>
					</div>
				</li>
				<li>
					<div class="title">Les boucles FOR et WHILE en PHP</div>
					<div class="description">
						On apprend ici comment utiliser des boucles en PHP, c'est-à-dire 
						comment répéter un traitement plusieurs fois.
					</div>
					<div class="fichiers">
						Fichier(s) : php/exemples/boucles.php <br/> 
					</div>
					<div class="liens">
						<a href="php/exemples/boucles.php">Voir l'exemple</a>
					</div>
				</li>
				<li>
					<div class="title">Les fonctions et procédures en PHP</div>
					<div class="description">
						On apprend ici comment créer et utiliser ses propres fonctions 
						et procédure en PHP. On constate leur utilité afin de créer 
						des programmes réutilisables.
					</div>
					<div class="fichiers">
						Fichier(s) : php/exemples/fonctions.php <br/> 
					</div>
					<div class="liens">
						<a href="php/exemples/fonctions.php">Voir l'exemple</a>
					</div>
				</li>
				<li>
					<div class="title">La manipulation d'une base de données en PHP</div>
					<div class="description">
						On apprend ici comment se connecter et interagir avec une base 
						de données MySQL en PHP. 
					</div>
					<div class="fichiers">
						Fichier(s) : php/exemples/mysql.php <br/> 
					</div>
					<div class="liens">
						<a href="php/exemples/mysql.php">Voir l'exemple</a>
					</div>
				</li>
			</ul>
			
			<h1 id="h1-exercices">Exercices PHP</h1>
			
			<div class="phrase">
				Liste d'exercices PHP :
			</div>
			
			<ul class="exercices">
				<li>
					<div class="title">Se familiariser avec le PHP</div>
					<div class="description">
						L'objectif de cet exercice d'introduction est de se familiariser 
						avec plusieurs notions de programmation au travers de la rédaction 
						de petits programmes. On abordera ainsi la plupart des notions 
						évoquées dans les exemples disponibles : variables, tableaux, tableaux 
						associatifs, paramètres GET et POST, conditions, boucles et fonctions.
					</div>
					<div class="fichiers">
						Fichier(s) : php/exercices/introduction.php, php/exercices/introduction/*.php
					</div>
					<div class="liens">
						<a href="php/exercices/introduction.php">Voir l'exercice</a>
						<a href="php/corrections/introduction.php">Voir le corrigé</a>
					</div>
				</li>
				<li>
					<div class="title">Réaliser un questionnaire en PHP</div>
					<div class="description">
						L'objectif de cet exercice est de mettre en oeuvre, en un seul 
						programme PHP, une grande partie des notions abordées dans les 
						exemples PHP fournis. Ici, il s'agit de réaliser un questionnaire 
						en PHP.
					</div>
					<div class="fichiers">
						Fichier(s) : php/exercices/questionnaire.php, php/exercices/questionnaire/*.php
					</div>
					<div class="liens">
						<a href="php/exercices/questionnaire.php">Voir l'exercice</a>
						<a href="php/corrections/questionnaire.php">Voir le corrigé</a>
					</div>
				</li>
				<li>
					<div class="title">Développer un système d'authentification en PHP</div>
					<div class="description">
						Cet exercice, assez complet, a pour object de mettre en oeuvre 
						une grande partie des notions abordées dans les exemples proposés. 
						Il vise à réaliser un système d'authentification simple.
					</div>
					<div class="fichiers">
						Fichier(s) : php/exercices/connexion.php, php/exercices/connexion/*.php
					</div>
					<div class="liens">
						<a href="php/exercices/connexion.php">Voir l'exercice</a>
						<a href="php/corrections/connexion.php">Voir le corrigé</a>
					</div>
				</li>
			</ul>
			
		</section>
		
	</body>
</html>
