<?php
	
	// En-tête
	$title = "Les variables en PHP";
	include("../header.php");
	 
?>

<h2>Les variables simples</h2>

<div class="phrase">
	Une variable est en quelque sorte une "case invisible" en mémoire 
	à laquelle on donne un nom. On peut mettre une valeur dans cette "case"
	à partir de son nom. On peut encore modifier la valeur de cette "case". 
	Cette "case" a une et une seule valeur qui peut évoluer au fil du programme 
	PHP. Une variable a donc un nom et une valeur.
	<br/><br/>
	L'opération consistant à créer une variable s'appelle une <b>déclaration 
	de variable</b> et l'opération consistant à modifier la valeur d'une 
	variable s'appelle une <b>affectation</b>.
</div>

<div class="code">
	<code>
		// Création deux variables de type chaînes de caractères
		$message1 = "Hello world !";
		$message2 = "How are you ?";
		// Création de trois variables de type numérique 
		$nombre1 = 5;
		$nombre2 = 7.50;
		$nombre3 = 10;
	</code>
</div>

<?php
	
	// Création deux variables de type chaînes de caractères
	$message1 = "Hello world !";
	$message2 = "How are you ?";
	// Création de trois variables de type numérique 
	$nombre1 = 5;
	$nombre2 = 7.50;
	$nombre3 = 10;
	
?>

<div class="phrase">
	Avoir des variables ne suffit pas. Il faut les utiliser. On peut 
	par exemple afficher le contenu d'une variable au moyen de la 
	fonction <b>echo($maVariable)</b>.
	<br/><br/>
	On peut encore effectuer diverses opérations sur les variables, par 
	exemple : des additions, des multiplications, des divisions, des 
	soustractions ou encore des concaténations*. On peut en fait effectuer 
	de multiples autres opérations.
	<br/><br/> 
	<i>
		* La <b>concaténation</b> est l'opération qui consiste à mettre 
		deux chaînes de caractères côte-à-côte, à les regrouper.
	</i>
	<br/><br/>
	Affichons donc le contenu des variables que nous avons créées mais 
	encore le résultat de quelques opérations élémentaires.
</div>

<div class="code">
	<code>
		// Affichage de toutes les variables créées avec un saut à la ligne à 
		// chaque fois. Le caractère "." permet d'effectuer une concaténation.
		echo("message1 => " . $message1 . "&lt;br/>");
		echo("message2 => " . $message2 . "&lt;br/>");
		echo("nombre1 => " . $nombre1 . "&lt;br/>");
		echo("nombre2 => " . $nombre2 . "&lt;br/>");
		echo("nombre3 => " . $nombre3 . "&lt;br/>");
		
		// Modification de la valeur de $nombre1 puis affichage
		$nombre1 = 2.50;
		echo("nombre3 => " . $nombre1 . "&lt;br/>");
		
		// Création de variables dont la valeur est calculée en outre à partir 
		// des variables que nous avons précédemment créées. 
		$message3 = $message1 . " " . $message2;
		$nombre4 = $nombre1 + $nombre2;
		$nombre5 = $nombre1 * $nombre3;
		$nombre6 = $nombre3 / $nombre1;
		$nombre7 = $nombre3 - 5;
		
		// Affichage du contenu de nos nouvelles variables.
		echo("message3 => " . $message3);
		echo("nombre4 => " . $nombre4);
		echo("nombre5 => " . $nombre5);
		echo("nombre6 => " . $nombre6);
		echo("nombre7 => " . $nombre7);
		
		// On peut aussi modifier la valeur d'une variable à partir de la 
		// valeur qu'elle avait elle-même.
		$nombre7 = $nombre7 * $nombre7;
		echo("nombre7 => " . $nombre7);
		$nombre7 = $nombre7 + 1;
		echo("nombre7 => " . $nombre7);
		$nombre7++;
		echo("nombre7 => " . $nombre7);
	</code>
</div>

<div class="resultat">
	<?php
		
		// Affichage de toutes les variables créées avec un saut à la ligne à 
		// chaque fois. Le caractère "." permet d'effectuer une concaténation.
		echo("message1 => " . $message1 . "<br/>");
		echo("message2 => " . $message2 . "<br/>");
		echo("nombre1 => " . $nombre1 . "<br/>");
		echo("nombre2 => " . $nombre2 . "<br/>");
		echo("nombre3 => " . $nombre3 . "<br/>");
		
		// Modification de la valeur de $nombre1 puis affichage
		$nombre1 = 2.50;
		echo("nombre3 => " . $nombre1 . "<br/>");
		
		// Création de variables dont la valeur est calculée en outre à partir 
		// des variables que nous avons précédemment créées. 
		$message3 = $message1 . " " . $message2;
		$nombre4 = $nombre1 + $nombre2;
		$nombre5 = $nombre1 * $nombre3;
		$nombre6 = $nombre3 / $nombre1;
		$nombre7 = $nombre3 - 5;
		
		// Affichage du du contenu de nos nouvelles variables.
		echo("message3 => " . $message3 . "<br/>");
		echo("nombre4 => " . $nombre4 . "<br/>");
		echo("nombre5 => " . $nombre5 . "<br/>");
		echo("nombre6 => " . $nombre6 . "<br/>");
		echo("nombre7 => " . $nombre7 . "<br/>");
		
		// On peut aussi modifier la valeur d'une variable à partir de la 
		// valeur qu'elle avait elle-même.
		$nombre7 = $nombre7 * $nombre7;
		echo("nombre7 => " . $nombre7 . "<br/>");
		$nombre7 = $nombre7 + 1;
		echo("nombre7 => " . $nombre7 . "<br/>");
		$nombre7++;
		echo("nombre7 => " . $nombre7 . "<br/>");
		
	?>
</div>

<h2>Les variables tableaux</h2>

<div class="phrase">
	Un tableau est une variable qui peut contenir un ensemble de valeurs. 
	La valeur du tableau, c'est exactement cet ensemble de valeurs. 
	Un tableau est constitué de valeurs qui ont chacune un <b>index</b>.
	<br/><br/>
	L'index est en quelque sorte le numéro d'une "case" du tableau.
	<br/><br/>
	Les tableaux permettent donc de stocker une série de valeurs. On peut 
	effectuer de multiples opérations sur un tableau. En particulier, on 
	peut ajouter une valeur au tableau, récupérer la taille du tableau 
	(c'est-à-dire son nombre de "cases"), modifier la valeur d'une "case", 
	etc.
	<br/><br/>
	En PHP, le premier élément d'un tableau se trouve à l'index 0. Si le 
	tableau a n cases, alors l'index de la dernière case est n-1. On peut 
	créer un tableau grâce au mot-clef <b>array</b> et on peut récupérer 
	la taille du tableau grâce à la fonction <b>count($monTableau)</b>.
</div>

<div class="code">
	<code>
		// Création d'un tableau vide.
		$vide = array();
		// Création d'un tableau de nombres.
		$nombres = array(5, 10, 15, 20, 25);
		// Création d'un tableau de chaînes de caractères.
		$chaines = array("Je", "suis", "un", "tableau");
		// Création d'un tableau à partir de nos précédentes variables 
		$variables = array($message1, $message2);
		
		// Récupération puis affichage du nombre d'éléments de chaque tableau
		$nbVide = count($vide);
		$nbNombres = count($nombres);
		$nbChaines = count($chaines);
		$nbVariables = count($variables);
		echo "Il y a " . $nbVide . " éléments dans la variable 'vide'. &lt;br/>";
		echo "Il y a " . $nbNombres . " éléments dans la variable 'nombres'. &lt;br/>";
		echo "Il y a " . $nbChaines . " éléments dans la variable 'chaines'. &lt;br/>";
		echo "Il y a " . $nbVariables . " éléments dans la variable 'variables'. &lt;br/>";
		
		// Ajout d'un élément (une "case") au tableau de nombre puis affichage 
		// du nombre d'éléments dans $nombres
		$nombres[] = 30;
		$nbNombres = count($nombres);
		echo "Il y a à présent " . $nbNombres . " éléments dans la variable 'nombres'. &lt;br/>";
		
		// Affichage du premier et du dernier élément de chaque tableau.
		echo("nombres => " . $nombres[0] . ", ..., " . $nombres[$nbNombres-1] . "&lt;br/>");
		echo("chaînes => " . $chaines[0] . ", ..., " . $chaines[$nbChaines-1] . "&lt;br/>");
		echo("variables => " . $variables[0] . ", ..., " . $variables[$nbVariables-1] . "&lt;br/>");
		
		// Modification des valeurs du tableau de nombres puis affichage du premier 
		// et du dernier nombre du tableau.
		$nombres[0] = 2;
		$nombres[1] = 4;
		$nombres[2] = 6;
		$nombres[3] = 8;
		$nombres[4] = 10;
		$nombres[5] = 12;
		echo("nombres => " . $nombres[0] . ", ..., " . $nombres[$nbNombres-1] . "&lt;br/>");
		
		// Suppression du premier et du dernier élément du tableau de nombres grâce 
		// à la fonction unset($maVariable).
		unset($nombres[0]);
		unset($nombres[$nbNombres-1]);
		
		// Pour afficher le contenu d'un tableau dont on veut connaître les valeurs 
		// lorsqu'on développe en PHP, à des fins de test, on peut utiliser la fonction 
		// var_dump($monTableau).
		var_dump($nombres);
		
	</code>
</div>

<div class="resultat">
	<?php
	
		// Création d'un tableau vide.
		$vide = array();
		// Création d'un tableau de nombres.
		$nombres = array(5, 10, 15, 20, 25);
		// Création d'un tableau de chaînes de caractères.
		$chaines = array("Je", "suis", "un", "tableau");
		// Création d'un tableau à partir de nos précédentes variables 
		$variables = array($message1, $message2);
		
		// Récupération puis affichage du nombre d'éléments de chaque tableau
		$nbVide = count($vide);
		$nbNombres = count($nombres);
		$nbChaines = count($chaines);
		$nbVariables = count($variables);
		echo "Il y a " . $nbVide . " éléments dans la variable 'vide'. <br/>";
		echo "Il y a " . $nbNombres . " éléments dans la variable 'nombres'. <br/>";
		echo "Il y a " . $nbChaines . " éléments dans la variable 'chaines'. <br/>";
		echo "Il y a " . $nbVariables . " éléments dans la variable 'variables'. <br/>";
		
		// Ajout d'un élément (une "case") au tableau de nombre puis affichage 
		// du nombre d'éléments dans $nombres
		$nombres[] = 30;
		$nbNombres = count($nombres);
		echo "Il y a à présent " . $nbNombres . " éléments dans la variable 'nombres'. <br/>";
		
		// Affichage du premier et du dernier élément de chaque tableau.
		echo("nombres => " . $nombres[0] . ", ..., " . $nombres[$nbNombres-1] . "<br/>");
		echo("chaînes => " . $chaines[0] . ", ..., " . $chaines[$nbChaines-1] . "<br/>");
		echo("variables => " . $variables[0] . ", ..., " . $variables[$nbVariables-1] . "<br/>");
		
		// Modification des valeurs du tableau de nombres puis affichage du premier 
		// et du dernier nombre du tableau.
		$nombres[0] = 2;
		$nombres[1] = 4;
		$nombres[2] = 6;
		$nombres[3] = 8;
		$nombres[4] = 10;
		$nombres[5] = 12;
		echo("nombres => " . $nombres[0] . ", ..., " . $nombres[$nbNombres-1] . "<br/>");
		
		// Suppression du premier et du dernier élément du tableau de nombres grâce 
		// à la fonction unset($maVariable).
		unset($nombres[0]);
		unset($nombres[$nbNombres-1]);
		
		// Pour afficher le contenu d'un tableau dont on veut connaître les valeurs 
		// lorsqu'on développe en PHP, à des fins de test, on peut utiliser la fonction 
		// var_dump($monTableau).
		var_dump($nombres);
	
	?>
</div>

<h2>Les variables tableaux associatifs</h2>

<div class="phrase">
	Un tableau associatif est un tableau où les index sont typiquement des 
	chaînes de caractères. En fait, les tableaux PHP permettent également 
	d'associer une valeur à une autre valeur. Les paramètres GET et POST 
	constituent un exemple de tableaux associatifs (voir 
	<a href="php/exemples/parametres.php">Les paramètres GET et POST 
	en PHP</a>).
</div>

<div class="code">
	<code>
		// Création d'un tableau associatif.
		$personnes = array(
			"Gérard" => "77 ans",
			"Pauline" => "15 ans",
			"Georgette" => "82 ans",
			"Nazli" => "28 ans"
		);
		
		// Ajout d'une valeur au tableau associatif
		$personnes["Chuck"] = "6 ans";
		
		// Modification d'une valeur 
		$personnes["Georgette"] = "92 ans";
		
		// Affichage des valeur du tableau
		echo $personnes["Gérard"] . "&lt;br/>";
		echo $personnes["Pauline"] . "&lt;br/>";
		echo $personnes["Georgette"] . "&lt;br/>";
		echo $personnes["Nazli"] . "&lt;br/>";
		echo $personnes["Chuck"] . "&lt;br/>";
	</code>
</div>

<div class="resultat">
	<?php
		// Création d'un tableau associatif.
		$personnes = array(
			"Gérard" => "77 ans",
			"Pauline" => "15 ans",
			"Georgette" => "82 ans",
			"Nazli" => "28 ans"
		);
		
		// Ajout d'une valeur au tableau associatif
		$personnes["Chuck"] = "6 ans";
		
		// Modification d'une valeur 
		$personnes["Georgette"] = "92 ans";
		
		// Affichage des valeur du tableau
		echo $personnes["Gérard"] . "<br/>";
		echo $personnes["Pauline"] . "<br/>";
		echo $personnes["Georgette"] . "<br/>";
		echo $personnes["Nazli"] . "<br/>";
		echo $personnes["Chuck"] . "<br/>";
	?>
</div>

<?php
	
	// Pied de page
	include("../footer.php");
	
?>
