<?php
	
	// Utilitaires PHP
	require_once("utilities.php");
	
	// Permet d'utiliser les paramètres de session et de faire en 
	// sorte que les paramètres de session aient une durée de vie 
	// de 30 minutes.
	$duree = 30*60;
	ini_set("session.gc_maxlifetime", $duree);
	session_start();
	setcookie(session_name(),session_id(),time()+$duree); 
	
	// Base URL. La base URL permet d'utiliser des liens relatifs,
	// typiquement relatif au dossier dans lequel se trouve 
	// l'application. Le navigateur préfixe tous les liens relatifs 
	// par la base URL. Par exemple, si la base URL est "/tutoriel/", 
	// le navigateur considère que le lien relatif "img/fond.jpg" 
	// est équivalent à l'URI "/tutoriel/img/fond.jpg".
	$base = str_replace("\\", "/", explode("www", dirname(__DIR__))[1]) . "/";
	
?>

<!DOCTYPE html>
<html>
	<head>
		<!-- Permet d'utiliser des chemins (URI) relatifs au dossier du projet PHP -->
		<base href="<?=$base?>" />
		<!-- Titre de la page web -->
		<title><?=$title?></title>	
		<!-- Métadonnées permettant d'éviter des problèmes d'affichage des contenus textuels -->
		<meta charset="UTF-8">
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<!-- Favicon, c'est-à-dire icône figurant dans l'onglet sur le navigateur -->
		<link rel="icon" type="image/png" href="img/logo.png" />
		<!-- Feuille(s) de styles CSS -->
		<link rel="stylesheet" href="css/general.css" />
		<?php if(isset($css)){ ?>
		<link rel="stylesheet" href="<?=$css?>" />
		<?php } ?>
	</head>
	<body>
				
		<!-- Contenu de la page d'accueil (rubriques) -->
	
		<section class="contenu">
			
			<h1><?=$title?></h1>
			
			<a class="retour" href="<?=$base?>">Retour</a>

